#include "theSecrets.h"
#include "theCerts.h"

#ifdef ESP32
#include "WiFi.h"
#include "esp_wifi.h"
#elif defined(ESP8266)
#include "ESP8266WiFi.h"
#define LED 2
#endif

#include "Firewall.hpp"
#include "API.hpp"

fw::Firewall *firewall;
fw::API *firewallApi;

WiFiServer wifiServer(80);

#ifdef ESP8266
void toggleLED()
{
  if (digitalRead(LED) == LOW)
    digitalWrite(LED, HIGH);
  else
    digitalWrite(LED, LOW);
}
#endif

void setup()
{
#ifdef ESP8266
  pinMode(LED, OUTPUT);
#endif
  Serial.begin(115200);
  Serial.println();
  WiFi.begin(ssid, psk);
  while (!WiFi.isConnected())
  {
#ifdef ESP8266
    toggleLED();
#endif
    Serial.print(".");
    delay(200);
  }
  Serial.println();
  Serial.print("[WiFi] IP: ");
  Serial.println(WiFi.localIP());
  firewall = new fw::Firewall();
  firewallApi = new fw::API(firewall, cert, key, username, password);
  wifiServer.begin();
}

void loop()
{
  firewallApi->handle_client();
  WiFiClient client = wifiServer.available();
  if (client)
  {
    if (firewall->is_client_allowed(client))
    {
      Serial.println("allowed");
      client.stop();
    }
    else
    {
      Serial.println("rejected");
      client.flush();
    }
  }
}